diff --git a/src/backend/parser/parse_oper.c b/src/backend/parser/parse_oper.c
index cf64afbd85..2c165bb1be 100644
--- a/src/backend/parser/parse_oper.c
+++ b/src/backend/parser/parse_oper.c
@@ -249,14 +249,14 @@ get_sort_group_operators(Oid argtype,
 Oid
 oprid(Operator op)
 {
-	return ((Form_pg_operator) GETSTRUCT(op))->oid;
+	return (GETSTRUCT(pg_operator, op))->oid;
 }
 
 /* given operator tuple, return the underlying function's OID */
 Oid
 oprfuncid(Operator op)
 {
-	Form_pg_operator pgopform = (Form_pg_operator) GETSTRUCT(op);
+	Form_pg_operator pgopform = GETSTRUCT(pg_operator, op);
 
 	return pgopform->oprcode;
 }
@@ -471,7 +471,7 @@ compatible_oper(ParseState *pstate, List *op, Oid arg1, Oid arg2,
 		return (Operator) NULL; /* must be noError case */
 
 	/* but is it good enough? */
-	opform = (Form_pg_operator) GETSTRUCT(optup);
+	opform = GETSTRUCT(pg_operator, optup);
 	if (IsBinaryCoercible(arg1, opform->oprleft) &&
 		IsBinaryCoercible(arg2, opform->oprright))
 		return optup;
@@ -705,7 +705,7 @@ make_op(ParseState *pstate, List *opname, Node *ltree, Node *rtree,
 		tup = oper(pstate, opname, ltypeId, rtypeId, false, location);
 	}
 
-	opform = (Form_pg_operator) GETSTRUCT(tup);
+	opform = GETSTRUCT(pg_operator, tup);
 
 	/* Check it's not a shell */
 	if (!RegProcedureIsValid(opform->oprcode))
@@ -819,7 +819,7 @@ make_scalar_array_op(ParseState *pstate, List *opname,
 
 	/* Now resolve the operator */
 	tup = oper(pstate, opname, ltypeId, rtypeId, false, location);
-	opform = (Form_pg_operator) GETSTRUCT(tup);
+	opform = GETSTRUCT(pg_operator, tup);
 
 	/* Check it's not a shell */
 	if (!RegProcedureIsValid(opform->oprcode))
diff --git a/src/backend/parser/parse_relation.c b/src/backend/parser/parse_relation.c
index 926dcbf30e..84d7e05fa5 100644
--- a/src/backend/parser/parse_relation.c
+++ b/src/backend/parser/parse_relation.c
@@ -3243,7 +3243,7 @@ get_rte_attribute_is_dropped(RangeTblEntry *rte, AttrNumber attnum)
 				if (!HeapTupleIsValid(tp))	/* shouldn't happen */
 					elog(ERROR, "cache lookup failed for attribute %d of relation %u",
 						 attnum, rte->relid);
-				att_tup = (Form_pg_attribute) GETSTRUCT(tp);
+				att_tup = GETSTRUCT(pg_attribute, tp);
 				result = att_tup->attisdropped;
 				ReleaseSysCache(tp);
 			}
diff --git a/src/backend/parser/parse_type.c b/src/backend/parser/parse_type.c
index f7ad689459..65f0ab1489 100644
--- a/src/backend/parser/parse_type.c
+++ b/src/backend/parser/parse_type.c
@@ -247,7 +247,7 @@ LookupTypeNameOid(ParseState *pstate, const TypeName *typeName, bool missing_ok)
 		return InvalidOid;
 	}
 
-	typoid = ((Form_pg_type) GETSTRUCT(tup))->oid;
+	typoid = (GETSTRUCT(pg_type, tup))->oid;
 	ReleaseSysCache(tup);
 
 	return typoid;
@@ -272,7 +272,7 @@ typenameType(ParseState *pstate, const TypeName *typeName, int32 *typmod_p)
 				 errmsg("type \"%s\" does not exist",
 						TypeNameToString(typeName)),
 				 parser_errposition(pstate, typeName->location)));
-	if (!((Form_pg_type) GETSTRUCT(tup))->typisdefined)
+	if (!(GETSTRUCT(pg_type, tup))->typisdefined)
 		ereport(ERROR,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("type \"%s\" is only a shell",
@@ -294,7 +294,7 @@ typenameTypeId(ParseState *pstate, const TypeName *typeName)
 	Type		tup;
 
 	tup = typenameType(pstate, typeName, NULL);
-	typoid = ((Form_pg_type) GETSTRUCT(tup))->oid;
+	typoid = (GETSTRUCT(pg_type, tup))->oid;
 	ReleaseSysCache(tup);
 
 	return typoid;
@@ -313,7 +313,7 @@ typenameTypeIdAndMod(ParseState *pstate, const TypeName *typeName,
 	Type		tup;
 
 	tup = typenameType(pstate, typeName, typmod_p);
-	*typeid_p = ((Form_pg_type) GETSTRUCT(tup))->oid;
+	*typeid_p = (GETSTRUCT(pg_type, tup))->oid;
 	ReleaseSysCache(tup);
 }
 
@@ -348,14 +348,14 @@ typenameTypeMod(ParseState *pstate, const TypeName *typeName, Type typ)
 	 * for the shell-type case, since a shell couldn't possibly have a
 	 * typmodin function.
 	 */
-	if (!((Form_pg_type) GETSTRUCT(typ))->typisdefined)
+	if (!(GETSTRUCT(pg_type, typ))->typisdefined)
 		ereport(ERROR,
 				(errcode(ERRCODE_SYNTAX_ERROR),
 				 errmsg("type modifier cannot be specified for shell type \"%s\"",
 						TypeNameToString(typeName)),
 				 parser_errposition(pstate, typeName->location)));
 
-	typmodin = ((Form_pg_type) GETSTRUCT(typ))->typmodin;
+	typmodin = (GETSTRUCT(pg_type, typ))->typmodin;
 
 	if (typmodin == InvalidOid)
 		ereport(ERROR,
@@ -591,7 +591,7 @@ typeTypeId(Type tp)
 {
 	if (tp == NULL)				/* probably useless */
 		elog(ERROR, "typeTypeId() called with NULL type struct");
-	return ((Form_pg_type) GETSTRUCT(tp))->oid;
+	return (GETSTRUCT(pg_type, tp))->oid;
 }
 
 /* given type (as type struct), return the length of type */
@@ -600,7 +600,7 @@ typeLen(Type t)
 {
 	Form_pg_type typ;
 
-	typ = (Form_pg_type) GETSTRUCT(t);
+	typ = GETSTRUCT(pg_type, t);
 	return typ->typlen;
 }
 
@@ -610,7 +610,7 @@ typeByVal(Type t)
 {
 	Form_pg_type typ;
 
-	typ = (Form_pg_type) GETSTRUCT(t);
+	typ = GETSTRUCT(pg_type, t);
 	return typ->typbyval;
 }
 
@@ -620,7 +620,7 @@ typeTypeName(Type t)
 {
 	Form_pg_type typ;
 
-	typ = (Form_pg_type) GETSTRUCT(t);
+	typ = GETSTRUCT(pg_type, t);
 	/* pstrdup here because result may need to outlive the syscache entry */
 	return pstrdup(NameStr(typ->typname));
 }
@@ -631,7 +631,7 @@ typeTypeRelid(Type typ)
 {
 	Form_pg_type typtup;
 
-	typtup = (Form_pg_type) GETSTRUCT(typ);
+	typtup = GETSTRUCT(pg_type, typ);
 	return typtup->typrelid;
 }
 
@@ -641,7 +641,7 @@ typeTypeCollation(Type typ)
 {
 	Form_pg_type typtup;
 
-	typtup = (Form_pg_type) GETSTRUCT(typ);
+	typtup = GETSTRUCT(pg_type, typ);
 	return typtup->typcollation;
 }
 
@@ -653,7 +653,7 @@ typeTypeCollation(Type typ)
 Datum
 stringTypeDatum(Type tp, char *string, int32 atttypmod)
 {
-	Form_pg_type typform = (Form_pg_type) GETSTRUCT(tp);
+	Form_pg_type typform = GETSTRUCT(pg_type, tp);
 	Oid			typinput = typform->typinput;
 	Oid			typioparam = getTypeIOParam(tp);
 
@@ -674,7 +674,7 @@ typeidTypeRelid(Oid type_id)
 	typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type_id));
 	if (!HeapTupleIsValid(typeTuple))
 		elog(ERROR, "cache lookup failed for type %u", type_id);
-	type = (Form_pg_type) GETSTRUCT(typeTuple);
+	type = GETSTRUCT(pg_type, typeTuple);
 	result = type->typrelid;
 	ReleaseSysCache(typeTuple);
 	return result;
@@ -697,7 +697,7 @@ typeOrDomainTypeRelid(Oid type_id)
 		typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(type_id));
 		if (!HeapTupleIsValid(typeTuple))
 			elog(ERROR, "cache lookup failed for type %u", type_id);
-		type = (Form_pg_type) GETSTRUCT(typeTuple);
+		type = GETSTRUCT(pg_type, typeTuple);
 		if (type->typtype != TYPTYPE_DOMAIN)
 		{
 			/* Not a domain, so done looking through domains */
@@ -797,7 +797,7 @@ parseTypeString(const char *str, Oid *typeid_p, int32 *typmod_p, bool missing_ok
 	}
 	else
 	{
-		Form_pg_type typ = (Form_pg_type) GETSTRUCT(tup);
+		Form_pg_type typ = GETSTRUCT(pg_type, tup);
 
 		if (!typ->typisdefined)
 			ereport(ERROR,
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
index b57253463b..417a571529 100644
--- a/src/backend/parser/parse_utilcmd.c
+++ b/src/backend/parser/parse_utilcmd.c
@@ -693,7 +693,7 @@ transformColumnDefinition(CreateStmtContext *cxt, ColumnDef *column)
 								 errmsg("identity columns are not supported on partitions")));
 
 					ctype = typenameType(cxt->pstate, column->typeName, NULL);
-					typeOid = ((Form_pg_type) GETSTRUCT(ctype))->oid;
+					typeOid = (GETSTRUCT(pg_type, ctype))->oid;
 					ReleaseSysCache(ctype);
 
 					if (saw_identity)
@@ -1457,7 +1457,7 @@ transformOfType(CreateStmtContext *cxt, TypeName *ofTypename)
 
 	tuple = typenameType(NULL, ofTypename, NULL);
 	check_of_type(tuple);
-	ofTypeId = ((Form_pg_type) GETSTRUCT(tuple))->oid;
+	ofTypeId = (GETSTRUCT(pg_type, tuple))->oid;
 	ofTypename->typeOid = ofTypeId; /* cached for later */
 
 	tupdesc = lookup_rowtype_tupdesc(ofTypeId, -1);
@@ -1541,11 +1541,11 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 	ht_idxrel = SearchSysCache1(RELOID, ObjectIdGetDatum(source_relid));
 	if (!HeapTupleIsValid(ht_idxrel))
 		elog(ERROR, "cache lookup failed for relation %u", source_relid);
-	idxrelrec = (Form_pg_class) GETSTRUCT(ht_idxrel);
+	idxrelrec = GETSTRUCT(pg_class, ht_idxrel);
 
 	/* Fetch pg_index tuple for source index from relcache entry */
 	ht_idx = source_idx->rd_indextuple;
-	idxrec = (Form_pg_index) GETSTRUCT(ht_idx);
+	idxrec = GETSTRUCT(pg_index, ht_idx);
 	indrelid = idxrec->indrelid;
 
 	/* Fetch the pg_am tuple of the index' access method */
@@ -1553,7 +1553,7 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 	if (!HeapTupleIsValid(ht_am))
 		elog(ERROR, "cache lookup failed for access method %u",
 			 idxrelrec->relam);
-	amrec = (Form_pg_am) GETSTRUCT(ht_am);
+	amrec = GETSTRUCT(pg_am, ht_am);
 
 	/* Extract indcollation from the pg_index tuple */
 	datum = SysCacheGetAttr(INDEXRELID, ht_idx,
@@ -1620,7 +1620,7 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 			if (!HeapTupleIsValid(ht_constr))
 				elog(ERROR, "cache lookup failed for constraint %u",
 					 constraintId);
-			conrec = (Form_pg_constraint) GETSTRUCT(ht_constr);
+			conrec = GETSTRUCT(pg_constraint, ht_constr);
 
 			index->isconstraint = true;
 			index->deferrable = conrec->condeferrable;
@@ -1658,7 +1658,7 @@ generateClonedIndexStmt(RangeVar *heapRel, Relation source_idx,
 					if (!HeapTupleIsValid(opertup))
 						elog(ERROR, "cache lookup failed for operator %u",
 							 operid);
-					operform = (Form_pg_operator) GETSTRUCT(opertup);
+					operform = GETSTRUCT(pg_operator, opertup);
 					oprname = pstrdup(NameStr(operform->oprname));
 					/* For simplicity we always schema-qualify the op name */
 					nspname = get_namespace_name(operform->oprnamespace);
@@ -1889,7 +1889,7 @@ generateClonedExtStatsStmt(RangeVar *heapRel, Oid heapRelid,
 	ht_stats = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(source_statsid));
 	if (!HeapTupleIsValid(ht_stats))
 		elog(ERROR, "cache lookup failed for statistics object %u", source_statsid);
-	statsrec = (Form_pg_statistic_ext) GETSTRUCT(ht_stats);
+	statsrec = GETSTRUCT(pg_statistic_ext, ht_stats);
 
 	/* Determine which statistics types exist */
 	datum = SysCacheGetAttr(STATEXTOID, ht_stats,
@@ -2001,7 +2001,7 @@ get_collation(Oid collation, Oid actual_datatype)
 	ht_coll = SearchSysCache1(COLLOID, ObjectIdGetDatum(collation));
 	if (!HeapTupleIsValid(ht_coll))
 		elog(ERROR, "cache lookup failed for collation %u", collation);
-	coll_rec = (Form_pg_collation) GETSTRUCT(ht_coll);
+	coll_rec = GETSTRUCT(pg_collation, ht_coll);
 
 	/* For simplicity, we always schema-qualify the name */
 	nsp_name = get_namespace_name(coll_rec->collnamespace);
@@ -2028,7 +2028,7 @@ get_opclass(Oid opclass, Oid actual_datatype)
 	ht_opc = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclass));
 	if (!HeapTupleIsValid(ht_opc))
 		elog(ERROR, "cache lookup failed for opclass %u", opclass);
-	opc_rec = (Form_pg_opclass) GETSTRUCT(ht_opc);
+	opc_rec = GETSTRUCT(pg_opclass, ht_opc);
 
 	if (GetDefaultOpClass(actual_datatype, opc_rec->opcmethod) != opclass)
 	{
@@ -3771,7 +3771,7 @@ transformColumnType(CreateStmtContext *cxt, ColumnDef *column)
 
 	if (column->collClause)
 	{
-		Form_pg_type typtup = (Form_pg_type) GETSTRUCT(ctype);
+		Form_pg_type typtup = GETSTRUCT(pg_type, ctype);
 
 		LookupCollation(cxt->pstate,
 						column->collClause->collname,
diff --git a/src/backend/postmaster/autovacuum.c b/src/backend/postmaster/autovacuum.c
index 2e146aac93..a3ffd2947b 100644
--- a/src/backend/postmaster/autovacuum.c
+++ b/src/backend/postmaster/autovacuum.c
@@ -1910,7 +1910,7 @@ get_database_list(void)
 
 	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
 	{
-		Form_pg_database pgdatabase = (Form_pg_database) GETSTRUCT(tup);
+		Form_pg_database pgdatabase = GETSTRUCT(pg_database, tup);
 		avw_dbase  *avdb;
 		MemoryContext oldcxt;
 
@@ -1997,7 +1997,7 @@ do_autovacuum(void)
 	tuple = SearchSysCache1(DATABASEOID, ObjectIdGetDatum(MyDatabaseId));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for database %u", MyDatabaseId);
-	dbForm = (Form_pg_database) GETSTRUCT(tuple);
+	dbForm = GETSTRUCT(pg_database, tuple);
 
 	if (dbForm->datistemplate || !dbForm->datallowconn)
 	{
@@ -2055,7 +2055,7 @@ do_autovacuum(void)
 	 */
 	while ((tuple = heap_getnext(relScan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class classForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classForm = GETSTRUCT(pg_class, tuple);
 		PgStat_StatTabEntry *tabentry;
 		AutoVacOpts *relopts;
 		Oid			relid;
@@ -2148,7 +2148,7 @@ do_autovacuum(void)
 	relScan = table_beginscan_catalog(classRel, 1, &key);
 	while ((tuple = heap_getnext(relScan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class classForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classForm = GETSTRUCT(pg_class, tuple);
 		PgStat_StatTabEntry *tabentry;
 		Oid			relid;
 		AutoVacOpts *relopts = NULL;
@@ -2235,7 +2235,7 @@ do_autovacuum(void)
 			UnlockRelationOid(relid, AccessExclusiveLock);
 			continue;
 		}
-		classForm = (Form_pg_class) GETSTRUCT(tuple);
+		classForm = GETSTRUCT(pg_class, tuple);
 
 		/*
 		 * Make all the same tests made in the loop above.  In event of OID
@@ -2340,7 +2340,7 @@ do_autovacuum(void)
 		classTup = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 		if (!HeapTupleIsValid(classTup))
 			continue;			/* somebody deleted the rel, forget it */
-		isshared = ((Form_pg_class) GETSTRUCT(classTup))->relisshared;
+		isshared = (GETSTRUCT(pg_class, classTup))->relisshared;
 		ReleaseSysCache(classTup);
 
 		/*
@@ -2726,9 +2726,9 @@ extract_autovac_opts(HeapTuple tup, TupleDesc pg_class_desc)
 	bytea	   *relopts;
 	AutoVacOpts *av;
 
-	Assert(((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_RELATION ||
-		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_MATVIEW ||
-		   ((Form_pg_class) GETSTRUCT(tup))->relkind == RELKIND_TOASTVALUE);
+	Assert((GETSTRUCT(pg_class, tup))->relkind == RELKIND_RELATION ||
+		   (GETSTRUCT(pg_class, tup))->relkind == RELKIND_MATVIEW ||
+		   (GETSTRUCT(pg_class, tup))->relkind == RELKIND_TOASTVALUE);
 
 	relopts = extractRelOptions(tup, pg_class_desc, NULL);
 	if (relopts == NULL)
@@ -2767,7 +2767,7 @@ table_recheck_autovac(Oid relid, HTAB *table_toast_map,
 	classTup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(classTup))
 		return NULL;
-	classForm = (Form_pg_class) GETSTRUCT(classTup);
+	classForm = GETSTRUCT(pg_class, classTup);
 
 	/*
 	 * Get the applicable reloptions.  If it is a TOAST table, try to get the
diff --git a/src/backend/replication/logical/launcher.c b/src/backend/replication/logical/launcher.c
index 2bdab53e19..8f8d61d682 100644
--- a/src/backend/replication/logical/launcher.c
+++ b/src/backend/replication/logical/launcher.c
@@ -114,7 +114,7 @@ get_subscription_list(void)
 
 	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
 	{
-		Form_pg_subscription subform = (Form_pg_subscription) GETSTRUCT(tup);
+		Form_pg_subscription subform = GETSTRUCT(pg_subscription, tup);
 		Subscription *sub;
 		MemoryContext oldcxt;
 
diff --git a/src/backend/replication/logical/origin.c b/src/backend/replication/logical/origin.c
index 21937ab2d3..bcc8ce4451 100644
--- a/src/backend/replication/logical/origin.c
+++ b/src/backend/replication/logical/origin.c
@@ -218,7 +218,7 @@ replorigin_by_name(const char *roname, bool missing_ok)
 	tuple = SearchSysCache1(REPLORIGNAME, roname_d);
 	if (HeapTupleIsValid(tuple))
 	{
-		ident = (Form_pg_replication_origin) GETSTRUCT(tuple);
+		ident = GETSTRUCT(pg_replication_origin, tuple);
 		roident = ident->roident;
 		ReleaseSysCache(tuple);
 	}
@@ -460,7 +460,7 @@ replorigin_by_oid(RepOriginId roident, bool missing_ok, char **roname)
 
 	if (HeapTupleIsValid(tuple))
 	{
-		ric = (Form_pg_replication_origin) GETSTRUCT(tuple);
+		ric = GETSTRUCT(pg_replication_origin, tuple);
 		*roname = text_to_cstring(&ric->roname);
 		ReleaseSysCache(tuple);
 
diff --git a/src/backend/replication/logical/proto.c b/src/backend/replication/logical/proto.c
index ff8513e2d2..01f38d1b28 100644
--- a/src/backend/replication/logical/proto.c
+++ b/src/backend/replication/logical/proto.c
@@ -736,7 +736,7 @@ logicalrep_write_typ(StringInfo out, TransactionId xid, Oid typoid)
 	tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(basetypoid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", basetypoid);
-	typtup = (Form_pg_type) GETSTRUCT(tup);
+	typtup = GETSTRUCT(pg_type, tup);
 
 	/* use Oid as relation identifier */
 	pq_sendint32(out, typoid);
@@ -827,7 +827,7 @@ logicalrep_write_tuple(StringInfo out, Relation rel, TupleTableSlot *slot,
 		typtup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(att->atttypid));
 		if (!HeapTupleIsValid(typtup))
 			elog(ERROR, "cache lookup failed for type %u", att->atttypid);
-		typclass = (Form_pg_type) GETSTRUCT(typtup);
+		typclass = GETSTRUCT(pg_type, typtup);
 
 		/*
 		 * Send in binary if requested and type has suitable send function.
diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index 38e3b1c1b3..591d625c24 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -3939,7 +3939,7 @@ clear_subscription_skip_lsn(XLogRecPtr finish_lsn)
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "subscription \"%s\" does not exist", MySubscription->name);
 
-	subform = (Form_pg_subscription) GETSTRUCT(tup);
+	subform = GETSTRUCT(pg_subscription, tup);
 
 	/*
 	 * Clear the subskiplsn. If the user has already changed subskiplsn before
diff --git a/src/backend/rewrite/rewriteDefine.c b/src/backend/rewrite/rewriteDefine.c
index 185bf5fbff..75c7785044 100644
--- a/src/backend/rewrite/rewriteDefine.c
+++ b/src/backend/rewrite/rewriteDefine.c
@@ -128,7 +128,7 @@ InsertRule(const char *rulname,
 
 		ReleaseSysCache(oldtup);
 
-		rewriteObjectId = ((Form_pg_rewrite) GETSTRUCT(tup))->oid;
+		rewriteObjectId = (GETSTRUCT(pg_rewrite, tup))->oid;
 		is_update = true;
 	}
 	else
@@ -627,7 +627,7 @@ DefineQueryRewrite(const char *rulename,
 		classTup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(event_relid));
 		if (!HeapTupleIsValid(classTup))
 			elog(ERROR, "cache lookup failed for relation %u", event_relid);
-		classForm = (Form_pg_class) GETSTRUCT(classTup);
+		classForm = GETSTRUCT(pg_class, classTup);
 
 		classForm->relam = InvalidOid;
 		classForm->reltablespace = InvalidOid;
@@ -877,7 +877,7 @@ EnableDisableRule(Relation rel, const char *rulename,
 				 errmsg("rule \"%s\" for relation \"%s\" does not exist",
 						rulename, get_rel_name(owningRel))));
 
-	ruleform = (Form_pg_rewrite) GETSTRUCT(ruletup);
+	ruleform = GETSTRUCT(pg_rewrite, ruletup);
 
 	/*
 	 * Verify that the user has appropriate permissions.
@@ -928,7 +928,7 @@ RangeVarCallbackForRenameRule(const RangeVar *rv, Oid relid, Oid oldrelid,
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		return;					/* concurrently dropped */
-	form = (Form_pg_class) GETSTRUCT(tuple);
+	form = GETSTRUCT(pg_class, tuple);
 
 	/* only tables and views can have rules */
 	if (form->relkind != RELKIND_RELATION &&
@@ -991,7 +991,7 @@ RenameRewriteRule(RangeVar *relation, const char *oldName,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("rule \"%s\" for relation \"%s\" does not exist",
 						oldName, RelationGetRelationName(targetrel))));
-	ruleform = (Form_pg_rewrite) GETSTRUCT(ruletup);
+	ruleform = GETSTRUCT(pg_rewrite, ruletup);
 	ruleOid = ruleform->oid;
 
 	/* rule with the new name should not already exist */
diff --git a/src/backend/rewrite/rewriteRemove.c b/src/backend/rewrite/rewriteRemove.c
index 2b51683f6d..ad845f4124 100644
--- a/src/backend/rewrite/rewriteRemove.c
+++ b/src/backend/rewrite/rewriteRemove.c
@@ -71,7 +71,7 @@ RemoveRewriteRuleById(Oid ruleOid)
 	 * going on that might depend on this rule.  (Note: a weaker lock would
 	 * suffice if it's not an ON SELECT rule.)
 	 */
-	eventRelationOid = ((Form_pg_rewrite) GETSTRUCT(tuple))->ev_class;
+	eventRelationOid = (GETSTRUCT(pg_rewrite, tuple))->ev_class;
 	event_relation = table_open(eventRelationOid, AccessExclusiveLock);
 
 	if (!allowSystemTableMods && IsSystemRelation(event_relation))
diff --git a/src/backend/rewrite/rewriteSupport.c b/src/backend/rewrite/rewriteSupport.c
index 80e2509450..bb8c6c1fbd 100644
--- a/src/backend/rewrite/rewriteSupport.c
+++ b/src/backend/rewrite/rewriteSupport.c
@@ -64,7 +64,7 @@ SetRelationRuleStatus(Oid relationId, bool relHasRules)
 	tuple = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relationId));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
-	classForm = (Form_pg_class) GETSTRUCT(tuple);
+	classForm = GETSTRUCT(pg_class, tuple);
 
 	if (classForm->relhasrules != relHasRules)
 	{
@@ -109,7 +109,7 @@ get_rewrite_oid(Oid relid, const char *rulename, bool missing_ok)
 				 errmsg("rule \"%s\" for relation \"%s\" does not exist",
 						rulename, get_rel_name(relid))));
 	}
-	ruleform = (Form_pg_rewrite) GETSTRUCT(tuple);
+	ruleform = GETSTRUCT(pg_rewrite, tuple);
 	Assert(relid == ruleform->ev_class);
 	ruleoid = ruleform->oid;
 	ReleaseSysCache(tuple);
diff --git a/src/backend/statistics/extended_stats.c b/src/backend/statistics/extended_stats.c
index 7c02fb279f..609622bbb6 100644
--- a/src/backend/statistics/extended_stats.c
+++ b/src/backend/statistics/extended_stats.c
@@ -453,7 +453,7 @@ fetch_statentries_for_relation(Relation pg_statext, Oid relid)
 		List	   *exprs = NIL;
 
 		entry = palloc0(sizeof(StatExtEntry));
-		staForm = (Form_pg_statistic_ext) GETSTRUCT(htup);
+		staForm = GETSTRUCT(pg_statistic_ext, htup);
 		entry->statOid = staForm->oid;
 		entry->schema = get_namespace_name(staForm->stxnamespace);
 		entry->name = pstrdup(NameStr(staForm->stxname));
@@ -561,7 +561,7 @@ examine_attribute(Node *expr)
 								   ObjectIdGetDatum(stats->attrtypid));
 	if (!HeapTupleIsValid(typtuple))
 		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
-	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
+	stats->attrtype = GETSTRUCT(pg_type, typtuple);
 
 	/*
 	 * We don't actually analyze individual attributes, so no need to set the
@@ -663,7 +663,7 @@ examine_expression(Node *expr, int stattarget)
 	if (!HeapTupleIsValid(typtuple))
 		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
 
-	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
+	stats->attrtype = GETSTRUCT(pg_type, typtuple);
 	stats->anl_context = CurrentMemoryContext;	/* XXX should be using
 												 * something else? */
 	stats->tupattnum = InvalidAttrNumber;
diff --git a/src/backend/storage/large_object/inv_api.c b/src/backend/storage/large_object/inv_api.c
index d204482a61..e63c78c20c 100644
--- a/src/backend/storage/large_object/inv_api.c
+++ b/src/backend/storage/large_object/inv_api.c
@@ -412,7 +412,7 @@ inv_getsize(LargeObjectDesc *obj_desc)
 
 		if (HeapTupleHasNulls(tuple))	/* paranoia */
 			elog(ERROR, "null field found in pg_largeobject");
-		data = (Form_pg_largeobject) GETSTRUCT(tuple);
+		data = GETSTRUCT(pg_largeobject, tuple);
 		getdatafield(data, &datafield, &len, &pfreeit);
 		lastbyte = (uint64) data->pageno * LOBLKSIZE + len;
 		if (pfreeit)
@@ -534,7 +534,7 @@ inv_read(LargeObjectDesc *obj_desc, char *buf, int nbytes)
 
 		if (HeapTupleHasNulls(tuple))	/* paranoia */
 			elog(ERROR, "null field found in pg_largeobject");
-		data = (Form_pg_largeobject) GETSTRUCT(tuple);
+		data = GETSTRUCT(pg_largeobject, tuple);
 
 		/*
 		 * We expect the indexscan will deliver pages in order.  However,
@@ -662,7 +662,7 @@ inv_write(LargeObjectDesc *obj_desc, const char *buf, int nbytes)
 			{
 				if (HeapTupleHasNulls(oldtuple))	/* paranoia */
 					elog(ERROR, "null field found in pg_largeobject");
-				olddata = (Form_pg_largeobject) GETSTRUCT(oldtuple);
+				olddata = GETSTRUCT(pg_largeobject, oldtuple);
 				Assert(olddata->pageno >= pageno);
 			}
 			neednextpage = false;
@@ -848,7 +848,7 @@ inv_truncate(LargeObjectDesc *obj_desc, int64 len)
 	{
 		if (HeapTupleHasNulls(oldtuple))	/* paranoia */
 			elog(ERROR, "null field found in pg_largeobject");
-		olddata = (Form_pg_largeobject) GETSTRUCT(oldtuple);
+		olddata = GETSTRUCT(pg_largeobject, oldtuple);
 		Assert(olddata->pageno >= pageno);
 	}
 
diff --git a/src/backend/tcop/fastpath.c b/src/backend/tcop/fastpath.c
index d429aa4663..2311f1ad05 100644
--- a/src/backend/tcop/fastpath.c
+++ b/src/backend/tcop/fastpath.c
@@ -139,7 +139,7 @@ fetch_fp_info(Oid func_id, struct fp_info *fip)
 		ereport(ERROR,
 				(errcode(ERRCODE_UNDEFINED_FUNCTION),
 				 errmsg("function with OID %u does not exist", func_id)));
-	pp = (Form_pg_proc) GETSTRUCT(func_htp);
+	pp = GETSTRUCT(pg_proc, func_htp);
 
 	/* reject pg_proc entries that are unsafe to call via fastpath */
 	if (pp->prokind != PROKIND_FUNCTION || pp->proretset)
diff --git a/src/backend/tsearch/ts_selfuncs.c b/src/backend/tsearch/ts_selfuncs.c
index 8f2679f57e..69dcf0f327 100644
--- a/src/backend/tsearch/ts_selfuncs.c
+++ b/src/backend/tsearch/ts_selfuncs.c
@@ -165,7 +165,7 @@ tsquerysel(VariableStatData *vardata, Datum constval)
 		Form_pg_statistic stats;
 		AttStatsSlot sslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 
 		/* MCELEM will be an array of TEXT elements for a tsvector column */
 		if (get_attstatsslot(&sslot, vardata->statsTuple,
diff --git a/src/backend/utils/adt/acl.c b/src/backend/utils/adt/acl.c
index b7fd3bcf05..6ee7101357 100644
--- a/src/backend/utils/adt/acl.c
+++ b/src/backend/utils/adt/acl.c
@@ -603,7 +603,7 @@ aclitemout(PG_FUNCTION_ARGS)
 		htup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(aip->ai_grantee));
 		if (HeapTupleIsValid(htup))
 		{
-			putid(p, NameStr(((Form_pg_authid) GETSTRUCT(htup))->rolname));
+			putid(p, NameStr((GETSTRUCT(pg_authid, htup))->rolname));
 			ReleaseSysCache(htup);
 		}
 		else
@@ -631,7 +631,7 @@ aclitemout(PG_FUNCTION_ARGS)
 	htup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(aip->ai_grantor));
 	if (HeapTupleIsValid(htup))
 	{
-		putid(p, NameStr(((Form_pg_authid) GETSTRUCT(htup))->rolname));
+		putid(p, NameStr((GETSTRUCT(pg_authid, htup))->rolname));
 		ReleaseSysCache(htup);
 	}
 	else
@@ -2818,7 +2818,7 @@ convert_column_name(Oid tableoid, text *column)
 	{
 		Form_pg_attribute attributeForm;
 
-		attributeForm = (Form_pg_attribute) GETSTRUCT(attTuple);
+		attributeForm = GETSTRUCT(pg_attribute, attTuple);
 		/* We want to return NULL for dropped columns */
 		if (attributeForm->attisdropped)
 			attnum = InvalidAttrNumber;
@@ -4782,7 +4782,7 @@ has_rolinherit(Oid roleid)
 	utup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(roleid));
 	if (HeapTupleIsValid(utup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(utup))->rolinherit;
+		result = (GETSTRUCT(pg_authid, utup))->rolinherit;
 		ReleaseSysCache(utup);
 	}
 	return result;
@@ -4835,7 +4835,7 @@ roles_is_member_of(Oid roleid, enum RoleRecurseType type,
 		dbtup = SearchSysCache1(DATABASEOID, ObjectIdGetDatum(MyDatabaseId));
 		if (!HeapTupleIsValid(dbtup))
 			elog(ERROR, "cache lookup failed for database %u", MyDatabaseId);
-		dba = ((Form_pg_database) GETSTRUCT(dbtup))->datdba;
+		dba = (GETSTRUCT(pg_database, dbtup))->datdba;
 		ReleaseSysCache(dbtup);
 	}
 
@@ -4867,14 +4867,14 @@ roles_is_member_of(Oid roleid, enum RoleRecurseType type,
 		for (i = 0; i < memlist->n_members; i++)
 		{
 			HeapTuple	tup = &memlist->members[i]->tuple;
-			Oid			otherid = ((Form_pg_auth_members) GETSTRUCT(tup))->roleid;
+			Oid			otherid = (GETSTRUCT(pg_auth_members, tup))->roleid;
 
 			/*
 			 * While otherid==InvalidOid shouldn't appear in the catalog, the
 			 * OidIsValid() avoids crashing if that arises.
 			 */
 			if (otherid == admin_of &&
-				((Form_pg_auth_members) GETSTRUCT(tup))->admin_option &&
+				(GETSTRUCT(pg_auth_members, tup))->admin_option &&
 				OidIsValid(admin_of))
 				*is_admin = true;
 
@@ -5274,7 +5274,7 @@ get_rolespec_name(const RoleSpec *role)
 	char	   *rolename;
 
 	tp = get_rolespec_tuple(role);
-	authForm = (Form_pg_authid) GETSTRUCT(tp);
+	authForm = GETSTRUCT(pg_authid, tp);
 	rolename = pstrdup(NameStr(authForm->rolname));
 	ReleaseSysCache(tp);
 
diff --git a/src/backend/utils/adt/amutils.c b/src/backend/utils/adt/amutils.c
index 9d78a90d69..f04ed870fe 100644
--- a/src/backend/utils/adt/amutils.c
+++ b/src/backend/utils/adt/amutils.c
@@ -174,7 +174,7 @@ indexam_property(FunctionCallInfo fcinfo,
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(index_oid));
 		if (!HeapTupleIsValid(tuple))
 			PG_RETURN_NULL();
-		rd_rel = (Form_pg_class) GETSTRUCT(tuple);
+		rd_rel = GETSTRUCT(pg_class, tuple);
 		if (rd_rel->relkind != RELKIND_INDEX &&
 			rd_rel->relkind != RELKIND_PARTITIONED_INDEX)
 		{
@@ -229,7 +229,7 @@ indexam_property(FunctionCallInfo fcinfo,
 		tuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(index_oid));
 		if (!HeapTupleIsValid(tuple))
 			PG_RETURN_NULL();
-		rd_index = (Form_pg_index) GETSTRUCT(tuple);
+		rd_index = GETSTRUCT(pg_index, tuple);
 
 		Assert(index_oid == rd_index->indexrelid);
 		Assert(attno > 0 && attno <= rd_index->indnatts);
diff --git a/src/backend/utils/adt/array_selfuncs.c b/src/backend/utils/adt/array_selfuncs.c
index 8cbee1406b..9bac8771c1 100644
--- a/src/backend/utils/adt/array_selfuncs.c
+++ b/src/backend/utils/adt/array_selfuncs.c
@@ -139,7 +139,7 @@ scalararraysel_containment(PlannerInfo *root,
 		AttStatsSlot sslot;
 		AttStatsSlot hslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata.statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata.statsTuple);
 
 		/* MCELEM will be an array of same type as element */
 		if (get_attstatsslot(&sslot, vardata.statsTuple,
@@ -362,7 +362,7 @@ calc_arraycontsel(VariableStatData *vardata, Datum constval,
 		AttStatsSlot sslot;
 		AttStatsSlot hslot;
 
-		stats = (Form_pg_statistic) GETSTRUCT(vardata->statsTuple);
+		stats = GETSTRUCT(pg_statistic, vardata->statsTuple);
 
 		/* MCELEM will be an array of same type as column */
 		if (get_attstatsslot(&sslot, vardata->statsTuple,
diff --git a/src/backend/utils/adt/dbsize.c b/src/backend/utils/adt/dbsize.c
index 34efa121b4..403cbd0b13 100644
--- a/src/backend/utils/adt/dbsize.c
+++ b/src/backend/utils/adt/dbsize.c
@@ -857,7 +857,7 @@ pg_relation_filenode(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		PG_RETURN_NULL();
-	relform = (Form_pg_class) GETSTRUCT(tuple);
+	relform = GETSTRUCT(pg_class, tuple);
 
 	if (RELKIND_HAS_STORAGE(relform->relkind))
 	{
@@ -931,7 +931,7 @@ pg_relation_filepath(PG_FUNCTION_ARGS)
 	tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tuple))
 		PG_RETURN_NULL();
-	relform = (Form_pg_class) GETSTRUCT(tuple);
+	relform = GETSTRUCT(pg_class, tuple);
 
 	if (RELKIND_HAS_STORAGE(relform->relkind))
 	{
diff --git a/src/backend/utils/adt/domains.c b/src/backend/utils/adt/domains.c
index 3de0cb01a2..3d17b1de79 100644
--- a/src/backend/utils/adt/domains.c
+++ b/src/backend/utils/adt/domains.c
@@ -365,7 +365,7 @@ errdatatype(Oid datatypeOid)
 	tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(datatypeOid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", datatypeOid);
-	typtup = (Form_pg_type) GETSTRUCT(tup);
+	typtup = GETSTRUCT(pg_type, tup);
 
 	err_generic_string(PG_DIAG_SCHEMA_NAME,
 					   get_namespace_name(typtup->typnamespace));
